﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using C1SnippetsCore;
using C1.Web.UI.Controls.C1GridView;
using System.Data;

namespace C1Snippets
{
    public partial class GridView : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadGrid();
            }
        }

        protected void LoadGrid()
        {
            Dao dao = new Dao();
            C1GridView1.DataSource = Session["C1GridView1DataSource"] = dao.test();
            C1GridView1.DataBind();
        }

        protected void C1GridView1_PageIndexChanging(object sender, C1.Web.UI.Controls.C1GridView.C1GridViewPageEventArgs e)
        {
            ((C1GridView)sender).PageIndex = e.NewPageIndex;

            ((C1GridView)sender).DataSource = Session["C1GridView1DataSource"];
            ((C1GridView)sender).DataBind();
        }

        protected void C1GridView1_RowCommand(object sender, C1GridViewCommandEventArgs e)
        {

        }

        protected void C1GridView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void C1GridView1_RowCreated(object sender, C1GridViewRowEventArgs e)
        {
            if (e.Row.RowType == C1GridViewRowType.DataRow)
            {
                e.Row.Attributes["onclick"] = ClientScript.GetPostBackClientHyperlink(((C1GridView)sender), "Select:" + e.Row.RowIndex.ToString());
            }
        }

        protected void C1GridView1_Filtering(object sender, C1GridViewFilterEventArgs e)
        {
            ((C1GridView)sender).DataSource = Session["C1GridView1DataSource"];
            ((C1GridView)sender).DataBind();
        }

        private string GetSortDirection(string column)
        {
            // By default, set the sort direction to ascending.
            string sortDirection = "ASC";

            // Retrieve the last column that was sorted.
            string sortExpression = ViewState["SortExpression"] as string;

            if (sortExpression != null)
            {
                // Check if the same column is being sorted.
                // Otherwise, the default value can be returned.
                if (sortExpression == column)
                {
                    string lastDirection = ViewState["SortDirection"] as string;
                    if ((lastDirection != null) && (lastDirection == "ASC"))
                    {
                        sortDirection = "DESC";
                    }
                }
            }
            // Save new values in ViewState.
            ViewState["SortDirection"] = sortDirection;
            ViewState["SortExpression"] = column;

            return sortDirection;
        }

        protected void C1GridView1_Sorting(object sender, C1GridViewSortEventArgs e)
        {
            //Retrieve the table from the session object.
            DataTable dt = ((DataView)Session["C1GridView1DataSource"]).Table;

            if (dt != null)
            {
                //Sort the data.
                dt.DefaultView.Sort = e.SortExpression + " " + GetSortDirection(e.SortExpression);
                C1GridView1.DataSource = dt;
                C1GridView1.DataBind();
            }
        }
    }
}
